# avvy-l3


# pymerk


Проект по биндингу merk библиотеки для хранения, извлечения и доказательства наличия значений в дереве merkl.

Используется 

https://github.com/PyO3/pyo3
https://github.com/PyO3/setuptools-rust
https://docs.rs/crate/merk/2.0.1

## Prerequisittes:
```bash
curl --proto '=https' --tlsv1.2 -sSf https://sh.rustup.rs | sh && rustup default nightly
```

# ipfs 

Проект получившийся в результате исследования протокола ipfs, и технологий go-ipfs, ipfs-cluster. 

В `docker-compose.yml` поднятие ноды и системы для класстера. В `.env` - ключ для связывания нод в приватный класстер.

В `ansible` скрипты по разворачиванию ipfs ноды на виртуалках l2 и l3, с поднятием nginx для авторизации в webui ноды.

### !NB для работы ipfshttpclient требуется 7.0.0 версия ipfs демона. 
 

#### Добавление новой ipfs ноды:

Узнать адрес: 
```bash
ipfs id
```
Вернет что-то типа: 
```json
{
	"ID": "12D3KooWQb3zYKphrrstLdySD4vs3aQFdxdHGwruJNWBPrduiQ8i",
	"PublicKey": "CAESINt2M6jacbMHI3PYXHbKTEdtYvGw0jfxP/pjlbQSpgNj",
	"Addresses": [
		"/ip4/10.191.6.200/tcp/29182/p2p/12D3KooWQb3zYKphrrstLdySD4vs3aQFdxdHGwruJNWBPrduiQ8i",
		"/ip4/10.191.6.200/udp/29182/quic/p2p/12D3KooWQb3zYKphrrstLdySD4vs3aQFdxdHGwruJNWBPrduiQ8i",
		"/ip4/127.0.0.1/tcp/4001/p2p/12D3KooWQb3zYKphrrstLdySD4vs3aQFdxdHGwruJNWBPrduiQ8i",
		"/ip4/127.0.0.1/udp/4001/quic/p2p/12D3KooWQb3zYKphrrstLdySD4vs3aQFdxdHGwruJNWBPrduiQ8i",
		"/ip4/192.168.31.133/tcp/4001/p2p/12D3KooWQb3zYKphrrstLdySD4vs3aQFdxdHGwruJNWBPrduiQ8i",
		"/ip4/192.168.31.133/udp/4001/quic/p2p/12D3KooWQb3zYKphrrstLdySD4vs3aQFdxdHGwruJNWBPrduiQ8i",
		"/ip4/5.44.169.75/tcp/29182/p2p/12D3KooWQb3zYKphrrstLdySD4vs3aQFdxdHGwruJNWBPrduiQ8i", <-- этот адресс, ибо он имеет реальный ип.
		"/ip6/::1/tcp/4001/p2p/12D3KooWQb3zYKphrrstLdySD4vs3aQFdxdHGwruJNWBPrduiQ8i",
		"/ip6/::1/udp/4001/quic/p2p/12D3KooWQb3zYKphrrstLdySD4vs3aQFdxdHGwruJNWBPrduiQ8i"
	],
	"AgentVersion": "go-ipfs/0.7.0/",
	"ProtocolVersion": "ipfs/0.1.0",
	"Protocols": [
		"/ipfs/bitswap",
		"/ipfs/bitswap/1.0.0",
		"/ipfs/bitswap/1.1.0",
		"/ipfs/bitswap/1.2.0",
		"/ipfs/id/1.0.0",
		"/ipfs/id/push/1.0.0",
		"/ipfs/lan/kad/1.0.0",
		"/ipfs/ping/1.0.0",
		"/libp2p/autonat/1.0.0",
		"/libp2p/circuit/relay/0.1.0",
		"/p2p/id/delta/1.0.0",
		"/x/"
	]
}

```
адрес новой ноды прописать в уже существующей:

```bash
ipfs swarm connect <address>
```
И тогда можно гарантировать шаринг данных между этими нодами. 


# ws-server 

Грид сервер, работающий только по ws соединению, принимающий только json структуры с тем же протоколом. 
При запуске, все также, кроме инфы о запущенном гриде: {ws_connection: 'ws://host:port/ws'}
В остальном, все также.
TODO: тестирование, сi, и клиент с джсон данными. 

Открытые вопросы: ssl, мы не сможем каждому гриду дать домен, но можем проксировать. 
Например: wss://l3.avvyland.com/ws_conn/<grid_id> -> ws_connection


# grpc-server 

grpc сервер. Реализация узла из кластера L3. Принимает сообщения от клиента по grpc (протокол в protocol.proto), складывает в очередь inbox. Корутина работающая параллельно обрабатывает очередь инбокса каждый раз в заданное время, и формирует блок: обработанные хендлерами оутбокс добавляется в локальный меркл-сторадж, и сохраняется в ипфс и синхронизируется инфа в кластере L3.

Запуск тестового кластера: 

```
docker-compose up --build -d
```


Запуск тестового клиента: 

```
python client.py
```

Результат работы клиента - `messages_dt.csv` с информацией об имени, времени, nonce отправленного и обработанного сервером сообщения. 

# Нагрузочное тестирование. 

Необходимости:
- docker, python (с реквайронментсками), go 
- `avvy-l2` в установленном варианте. Например в папке `../avvy-l2`


Все происходит из директории l3_node. 
1) Запускаем ipfs ноду & mongo: `docker-compose up --build -d`
2) Запускаем starport: `chdir=../../avvy_l2/node starport chain serve`
3) Запускаем кластер l3: `./start_all_nodes.sh`
4) Запускаем клиента: `python load_test/l3_client.py`. Ждем завершения. 
5) Запускаем визуализацию `python load_test/make_graphics.py`, в результате в папке ./load_test будут result.jpg

