import asyncio
import os
import uuid

from aioipfs_api.client import Client

data_test_path = '/tmp/ipfs_test'
os.makedirs(data_test_path, exist_ok=True)


def make_test_stuff(where, count):
    data = (f'uuid:{uuid.uuid4()}' * count).encode()
    with open(where, 'wb') as f:
        for x in range(len(data) // 1000):
            f.write(data[x * 1000: (x + 1) * 1000])


async def main():
    make_test_stuff(os.path.join(data_test_path, 'test_data'), 1024 * 1024)

    async with Client(host='157.230.24.198') as client:
        result = await client.add(data_test_path, pin=True)
        

loop = asyncio.get_event_loop()
loop.run_until_complete(main())
