user www-data;
worker_processes auto;

error_log /var/log/nginx/error.log;
# pid /var/run/nginx.pid;

events {
    worker_connections 1024;
    use epoll;
}

http {
    map $http_upgrade $connection_upgrade {
        default upgrade;
        ''      close;
    }

    upstream ipfs_webui {
        server 127.0.0.1:5001;
    }
    access_log /var/log/nginx/access.log;
    proxy_next_upstream error;

    server {
        listen 80;


        location / {
            auth_basic           "Administrator’s Area";
            auth_basic_user_file /etc/nginx/ipfs-web.htpasswd;

            proxy_pass_header Server;
            proxy_set_header Host $http_host;
            proxy_redirect off;
            proxy_set_header X-Real-IP $remote_addr;
            proxy_set_header X-Scheme $scheme;
            proxy_pass http://ipfs_webui/;
        }

    }

    keepalive_timeout 604800;
    proxy_connect_timeout 604800;
    proxy_send_timeout 604800;
    proxy_read_timeout 604800;
}
