from contextlib import asynccontextmanager

from avvyprotocol.l3_pb2_grpc import L3ServiceStub
from grpc import aio

from core.utils import init_log

log = init_log('client')


@asynccontextmanager
async def connect_directly(uri):
    async with aio.insecure_channel(uri) as chan:
        stub = L3ServiceStub(channel=chan)
        yield stub
