import logging
import os

cur_path = os.path.dirname(__file__)

LOG_PATH = os.environ.get('GRPC_SERVER_LOGS_PATH', '/tmp/grpc-server-logs')
LOG_LEVEL = logging.INFO

IIDAP_ID = os.environ.get('IIDAP_ID', 'avvy-default-iidap')

TICK_FRAME_RATE_S = 0.1
ROLLUP_MAX_TXN_COUNT = int(os.environ.get('ROLLUP_MAX_TXN_COUNT', 10))
SHUTDOWN_WAIT_TICK_COUNT = int(os.environ.get('SHUTDOWN_WAIT_TICK_COUNT', 100))

# configuration for consensus storage
CONSENSUS_PASSWORD = os.environ.get('CONSENSUS_PASSWORD')
CONSENSUS_NODES_FILE = os.path.join(cur_path, 'cluster_nodes.yml')
CURRENT_NODE = os.environ.get('CURRENT_NODE', 'node1:7771:5051:54621')
NODE_INFO = lambda x: dict(zip(['host', 'raft_port', 'grpc_port', 'ws_port'], x.split(':')))

SYNC_BUFFER_SIZE = 2 ** 27
# configuration for data storage connection
IPFS_CONNECTION_URL = os.environ.get('IPFS_CONNECTION_URL', '/dns/ipfs/tcp/5001')
FILE_STORAGE_ROOT = os.environ.get('FILE_STORAGE_ROOT', '/tmp/avvy_l3')
FILE_TMP_STORAGE = os.path.join(FILE_STORAGE_ROOT, 'tmp')
os.makedirs(FILE_STORAGE_ROOT, exist_ok=True)

# default key path
KEY_PATH = os.environ.get('KEY_PATH', f'{FILE_STORAGE_ROOT}/{IIDAP_ID}_key.pem')

# L2 connection
L2_GRPC_HOST = os.environ.get('L2_GRPC_HOST', 'localhost')
L2_GRPC_PORT = os.environ.get('L2_GRPC_PORT', 9999)

