import os.path

from pymerk.pymerk import create_db, apply_batch, root_hash, get as merk_get

from config import FILE_STORAGE_ROOT, CURRENT_NODE


class Storage:
    """
    Доказательно хранит данные и имеет корень состояния.
    Под капотом - мерклрут бд, хранимая в фс.
    # todo оптимизация на стороне rust
    """

    def __init__(self, iidap_id):
        fname = os.path.join(FILE_STORAGE_ROOT, CURRENT_NODE, f'{iidap_id}_mrdb')
        if not os.path.exists(fname):
            create_db(fname)

        self._file_path = fname

    @property
    def file_path(self):
        return self._file_path

    def add_dict(self, input_dict):
        k_v = list(input_dict.items())
        k_v.sort(key=lambda x: x[0])
        ks, vs = [], []
        for k, v in k_v:
            ks.append(k)
            vs.append(str(v))

        return apply_batch(self.file_path, ks, vs)

    def get_raw(self, key):
        try:
            result = merk_get(path=self.file_path, key=key)
            return "".join(map(chr, result)).encode()
        except Exception as e:
            return None

    def get_root(self):
        result = root_hash(self.file_path)
        return "".join(map(chr, result)).encode()
