if [[ -z "${FT_PYVENV}" ]]; then
  PYVENV="/opt/venv/bin"
else
  PYVENV="${FT_PYVENV}"
fi
echo "PYVENV=$PYVENV"

serv_pids=""
CURRENT_NODE=node1:7771:5051:54321 ${PYVENV}/python main.py &
serv_pids+=" $!"
CURRENT_NODE=node2:7772:5052:54322 ${PYVENV}/python main.py &
serv_pids+=" $!"
CURRENT_NODE=node3:7773:5053:54323 ${PYVENV}/python main.py &
serv_pids+=" $!"
echo "Server pids: $serv_pids"

echo "Wait for servers start and warmup"
sleep 10;


client_pids=""
${PYVENV}/python client.py &
client_pids+=" $!"
${PYVENV}/python client.py &
client_pids+=" $!"

for clp in $client_pids; do
    if wait $clp; then
      echo "Client process [$clp] finished success"
    else
      echo "Client process [$clp] failed"
    fi
done

for sp in $serv_pids; do
    kill -15 $sp
    echo "Server process [$sp] killed"
done
