import matplotlib.pyplot as plt

from load_test.msg_store import ReadTestStore


def show_client_markers():
    rs = ReadTestStore()
    result = rs.get_by_clients_markers()
    x, y_avg, y_std = [], [], []

    fig, ax = plt.subplots()
    plt.title("Count clients per message time processing")
    plt.xlabel('count of clients')
    plt.ylabel('time of object processing, secs')

    for cl_marker, info in result.items():
        x.append(int(cl_marker))
        y_avg.append(info['avg_time'])
        y_std.append(info['std_time'])

    ax.scatter(x, y_avg, label='avg')
    ax.scatter(x, y_std, label='std')

    ax.legend()
    ax.grid(True)

    plt.savefig('./result.jpg')


if __name__ == '__main__':
    show_client_markers()
