import time

from pymerk.pymerk import create_db, root_hash, apply, apply_batch, get as merk_get


def main():
    db_name = './test.merkdb'
    print('not created', root_hash(db_name))
    create_db(db_name)
    print('created', root_hash(db_name))
    apply(db_name, 'test', 'value')
    print('applied once', root_hash(db_name))
    _start = time.time()
    apply_batch(db_name, ['test', 'test2', 'test3'], ['value', 'value2', 'value3'])
    keys = sorted([f'some_another_000000{i}' for i in range(100000)])
    values = sorted([f'value_another_00000{i}' for i in range(100000)])
    _start1 = time.time()
    apply_batch(db_name, keys, values)
    print(f'time 1: {_start1 - _start}, time 10000 {time.time() - _start1}')
    print('applied many', root_hash(db_name))
    result1 = merk_get(db_name, 'test')
    print(f'result1: {result1} {bytes(result1).decode()}')
    result2 = merk_get(db_name, 'test2')
    print(f'result2: {result2} {bytes(result2).decode()}')
    result3 = merk_get(db_name, 'test3')
    print(f'result2: {result3} {bytes(result3).decode()}')
    print('getted', root_hash(db_name))


if __name__ == '__main__':
    main()
