import os
import sys
import unittest

from core.utils import init_log

log = init_log(only_stream=True)


def main(test_path, test_pattern):
    log.info(('Discovering tests in : {}'.format(test_path)))
    suite = unittest.TestLoader().discover(test_path, test_pattern)
    result = unittest.TextTestRunner(verbosity=2).run(suite)
    if result.errors or result.failures or result.unexpectedSuccesses:
        sys.exit(-1)


if __name__ == '__main__':
    root_path = os.path.abspath('.')
    test_path = os.path.join(root_path, 'tests/')
    test_pattern = '*_test*'
    # test_pattern = 'subproc_test*'
    main(test_path, test_pattern)
