from aiohttp import web

from core.utils import init_log

log = init_log('ws')


class ClientConnection:
    def __init__(self, ws: web.WebSocketResponse):
        self.ws = ws

    async def handle_connection(self):
        async for msg in self.ws:
            log.debug(f'have ws message: {msg}')

    async def send_message(self, msg):
        try:
            await self.ws.send_bytes(msg.SerializeToString())
        except Exception as e:
            log.error()
            log.exception(e)

    async def close_connection(self, ws_close_code=None):
        try:
            await self.ws.close(code=ws_close_code or 1000)
        except Exception as e:
            log.exception(e)
