# Example 1
## Definition

```js
handler1(input)
{
    node22(value1, value2, value3, value4) 
    {
        value221 = node221(value1, value2)
        value222 = node222(value3, value4)
        return node223(value221, value222)    
    }
    value11 = node11(input)
    value12 = node12(input)
    value13 = node13(input)
    value21 = node21(value11, value12, value13, input)
    value22 = node22(value11, value12, value13, input)
    value31 = node31(value21, value22, input)
    value32 = node32(value21, value22, input)
    return output(value31, value32)
}

handler2(input) 
{
    value = handler1.node22.node221(input, input)
    return handler1.node22(value, value, value, input)
}
```

## Context-based semantic

```json
{
  "handler1": {
    "input": {
      "object": "props", "message": "props", "input": "string"
    },
    "children": {
      "node11": {
        "input": "string", "output": {"$concat": ["$input", "-node11"]}
      },
      "node12": {
        "input": "string", "output": {"$concat": ["$input", "-node12"]}
      },
      "node13": {
        "input": "string", "output": {"$concat": ["$input", "-node13"]}
      },
      "node21": {
        "input": {"value1": "string", "value2": "string", "value3": "string", "value4": "string"},
        "output": {
          "$concat": ["$input.value1", "$input.value2", "$input.value3", "$input.value4", "-node21"]
        }
      },
      "node22": {
        "input": {"value1": "string", "value2": "string", "value3": "string", "value4": "string"},
        "children": {
          "node221": {
            "input": {"value1": "string", "value2": "string"},
            "children": {"postfix": "-node221"},
            "output": {"$concat": ["$input.value1", "$input.value2", "$postfix"]}
          },
          "node222": {
            "input": {"value1": "string", "value2": "string"},
            "children": {"postfix": "-node222"},
            "output": {"$concat": ["$input.value1", "$input.value2", "$postfix"]}
          },
          "value221": {
            "$node221": {"value1": "$input.value1", "value2": "$input.value2"}
          },
          "value222": {
            "$node222": {"value1": "$input.value3", "value2": "$input.value4"}
          }
        },
        "output": {"$concat": ["$value221", "$value222"]}
      },
      "node31": {
        "input": {"value1": "string", "value2": "string", "value3": "string"},
        "children": {"postfix": "-node31"},
        "output": {"$concat": ["$input.value1", "$input.value2", "$input.value3", "$postfix"]}
      },
      "node32": {
        "input": {"value1": "string", "value2": "string", "value3": "string"},
        "children": {"prefix": "-node32"},
        "output": {"$concat": ["$input.value1", "$input.value2", "$input.value3", "$prefix"]}
      },
      "value11": {"$node11": "$input.input"},
      "value12": {"$node12": "$input.input"},
      "value13": {"$node13": "$input.input"},
      "value21": {"$node21": ["$value11", "value12", "value13", "$input.input"]},
      "value22": {"$node22": ["$value11", "value12", "value13","$input.input"]},
      "value31": {"$node31": ["$value21", "value22", "$input.input"]},
      "value32": {"$node32": ["$value21", "value22", "$input.input"]}
    },
    "output": {"$concat": ["$value31", "$value32"]}
  },
  "handler2": {
    "input": {"object": "props", "message": "props", "input": "string"},
    "children": {
      "value": {"$object.handler1.node22.node221": ["$input.input", "$input.input"]}
    },
    "output": {"$object.handler1.node22": ["$value", "$value", "$value", "$value"]}
  }
}
```

