package dsl

import (
	aproto "gitlab.domi.do/avvy/backend-protocol/proto/avvyprotocol"

	"gitlab.domi.do/avvy/avvy-l3/l3_node_golang/dsl/context"
	"gitlab.domi.do/avvy/avvy-l3/l3_node_golang/dsl/core"
	"gitlab.domi.do/avvy/avvy-l3/l3_node_golang/dsl/std"
)

type Contract struct {
	Ctx     Context
	Functor core.Functor
}

func New(fn core.Functor) *Contract {
	return &Contract{
		Ctx:     NewContext(),
		Functor: fn,
	}
}

func Build(payload *aproto.Payload) (c *Contract, err error) {
	var fn core.Functor
	ctx := context.NewContext(std.Std)
	fn, err = core.BuildCustomFunctor(payload, ctx)
	if err == nil {
		c = &Contract{
			Functor: fn,
			Ctx:     ctx,
		}
	}
	return
}

func (c *Contract) Exec(input *aproto.Payload) (output *aproto.Payload, err error) {

	var fnCall Unit

	if fnCall, err = core.BuildClosureFunctor(c.Functor, input, c.Ctx); err != nil {
		return
	}

	output, err = core.Payload(fnCall, c.Ctx.WithFunctor(c.Functor))

	return
}
