package core

import (
	"gitlab.domi.do/avvy/avvy-l3/l3_node_golang/dsl/interfaces"
	aproto "gitlab.domi.do/avvy/backend-protocol/proto/avvyprotocol"
)

const (
	ArgPrefix = "input"
)

func Build(payload *aproto.Payload, ctx interfaces.Context) (unit interfaces.Unit, err error) {
	if payload == nil {
		// err = errors.NULL_PAYLOAD_ERR
	} else if payload.GetFunctor() != nil {
		unit, err = BuildFunctor(payload, ctx)
	} else if props := payload.GetProps(); props != nil {
		if len(props.GetProps()) == 1 {
			prop := props.GetProps()[0]
			var ref *Ref
			if ref, err = BuildRef(prop.GetName(), ctx); ref != nil && err == nil {
				unit, err = BuildClosureByRef(ref, prop.GetValue(), ctx)
			}
		}
		if unit == nil && err == nil {
			unit, err = BuildProps(props.GetProps(), ctx)
		}
	} else if payload.GetListPayload() != nil {
		unit, err = BuildList(payload, ctx)
	} else if sing := payload.GetSingular(); sing != nil {
		unit, err = BuildRef(sing.GetStringValue(), ctx)
	}

	if unit == nil && err == nil {
		unit = &Value{Data: payload}
	}

	ctx.Step()
	return
}
