package core

import (
	"gitlab.domi.do/avvy/avvy-l3/l3_node_golang/dsl/errors"
	"gitlab.domi.do/avvy/avvy-l3/l3_node_golang/dsl/interfaces"
	"gitlab.domi.do/avvy/avvy-l3/l3_node_golang/dsl/typing"
)

type FunctorBuiltIn struct {
	Name         string
	Input        interfaces.Spec
	Output       interfaces.Spec
	OutputTypeFn func(input interfaces.Typable, ctx interfaces.Context) (t typing.Type)
	Fn           func(input interfaces.Input, ctx interfaces.Context) (unit interfaces.Unit, err error)
}

func (fn *FunctorBuiltIn) InputSpec() interfaces.Spec {
	return fn.Input
}

func (fn *FunctorBuiltIn) Eval(ctx interfaces.Context) (unit interfaces.Unit, err error) {
	switch arg := ctx.Get().(type) {
	case interfaces.Input:
		unit, err = fn.Fn(arg, ctx)
	case nil:
		return nil, errors.New("EMPTY STACK")
	default:
		return nil, errors.NOT_FULLY_EVALED_ERR
	}
	return
}

func (fn *FunctorBuiltIn) Type(ctx interfaces.Context) typing.Type {
	if fn.OutputTypeFn != nil {
		return fn.OutputTypeFn(ctx.Get(), ctx)
	}
	return fn.Output.Type(ctx)
}
