package errors

type Error struct {
	name string
}

func (err *Error) Error() string {
	return err.name
}

func New(name string) *Error {
	return &Error{name: name}
}

var (

	// Arg and refs
	REF_NOT_FOUND_ERR = New("REFERENCE NOT FOUND")
	ARG_NOT_FOUND_ERR = New("ARG NOT FOUND")
	EXTRA_ARG_ERR     = New("EXTRA ARG")

	// Eval
	NOT_FULLY_EVALED_ERR = New("NOT FULLY EVALED")
	BAD_PAYLOAD_ERR      = New("BAD PAYLOAD")
	NULL_PAYLOAD_ERR     = New("NULL PAYLOAD")

	INVALID_SYNTAX_ERR = New("INVALID SYNTAX")

	// Typing
	INCORRECT_TYPE_NOTATION_ERR = New("INCORRECT TYPE NOTATION")
	INVALID_TYPE_ERR            = New("INVALID TYPE")
	BAD_TYPE_ERR                = New("BAD TYPE")

	// Temporary error
	NOT_IMPLEMENTED_ERR = New("NOT IMPLEMENTED")
)
