package interfaces

import (
	"gitlab.domi.do/avvy/avvy-l3/l3_node_golang/dsl/typing"
	aproto "gitlab.domi.do/avvy/backend-protocol/proto/avvyprotocol"
)

type Evaluable interface {
	Eval(ctx Context) (Unit, error)
}

type Payloadable interface {
	Payload(ctx Context) (*aproto.Payload, error)
}

type Typable interface {
	Type(ctx Context) typing.Type
}

type Named interface {
	Name() string
}

type Unit interface {
	Evaluable
	Typable
}

type Functor interface {
	Evaluable
	Typable
	InputSpec() interface {
		Getter
		Keyable
		Sized
		Typable
	}
}

type Input interface {
	Evaluable
	Getter
	Typable
}
