package std

import (
	"log"

	"gitlab.domi.do/avvy/avvy-l3/l3_node_golang/dsl/core"
	"gitlab.domi.do/avvy/avvy-l3/l3_node_golang/dsl/typing"
	"gitlab.domi.do/avvy/avvy-l3/l3_node_golang/utils"
)

var (
	_ = Std.RegisterBuiltInFunc(&core.BuiltInFunctor{
		Name: "eq",
		Input: core.NewPropsSpec("", []core.Spec{
			&core.PropSpec{
				Key:       "a",
				ValueType: typing.TypeAny,
			},
			&core.PropSpec{
				Key:       "b",
				ValueType: typing.TypeAny,
			},
		}),
		Output: &core.PropSpec{ValueType: typing.TypeBool},
		Fn: func(input core.Input, ctx core.Context) (core.Unit, error) {
			a := input.Get("a")
			b := input.Get("b")

			ok := a.Type(ctx) == b.Type(ctx)

			log.Println(a.Type(ctx), b.Type(ctx))
			if ok {
			}

			return &core.UnitPayload{utils.BoolPayload(ok)}, nil
		},
	})
)
