package std

import (
	"gitlab.domi.do/avvy/avvy-l3/l3_node_golang/dsl/core"
	"gitlab.domi.do/avvy/avvy-l3/l3_node_golang/dsl/typing"
	"gitlab.domi.do/avvy/avvy-l3/l3_node_golang/utils"
)

var (
	_ = Std.RegisterBuiltInFunc(&core.BuiltInFunctor{
		Name: "concat",
		Input: core.NewPropsSpec("", []core.Spec{
			&core.PropSpec{
				Key: "a",
				ValueType: &typing.SetType{Types: []typing.Type{
					typing.TypeList,
					typing.TypeString,
				}},
			},
			&core.PropSpec{
				Key: "b",
				ValueType: &typing.SetType{Types: []typing.Type{
					typing.TypeList,
					typing.TypeString,
				}},
			},
		}),
		Output: &core.PropSpec{ValueType: typing.TypeAny},
		OutputTypeFn: func(input core.Typable, ctx core.Context) typing.Type {
			t := input.(core.UnitMap)["a"].Type(ctx)
			if input.(core.UnitMap)["b"].Type(ctx) != t {
				t = typing.TypeBad
			}
			return t
		},
		Fn: func(input core.Input, ctx core.Context) (unit core.Unit, err error) {
			a := core.PayloadNoErr(input.Get("a"), ctx).GetSingular().GetStringValue()
			b := core.PayloadNoErr(input.Get("b"), ctx).GetSingular().GetStringValue()
			unit, err = &core.UnitPayload{utils.StringPayload(a + b)}, nil
			return
		},
	})
)
