package errors

import "errors"

type Error struct {
	error
	Msg string
}

func New(msg string) *Error {
	return &Error{
		error: errors.New(msg),
	}
}

func (err Error) WithMsg(msg string) *Error {
	err.Msg = msg
	return &err
}

var (
	ErrNotImplemented = New("NOT IMPLEMENTED")

	ErrInterrupt     = New("INTERRUPT")
	ErrCycleDetected = New("CYCLE DETECTED")

	ErrFuncNotFound        = New("FUNCTION NOT FOUND")
	ErrTypeNotSpecified    = New("TYPE NOT SPECIFIED")
	ErrNotEnoughTypeParams = New("NOT ENOUGH TYPE PARAMS")
	ErrNotEnoughArgs       = New("NOT ENOUGH ARGS")
	ErrExtraArgs           = New("EXTRA ARGS")
	ErrUnnamedArgs         = New("UNNAMED ARGS SHOULD BE BEFORE NAMED")

	ErrPropsNotSorted  = New("PROPS ARE NOT SORTED")
	ErrPropNotFound    = New("PROP NOT FOUND")
	ErrProtectedProp   = New("CAN'T MODIFY PROTECTED PROP")
	ErrHandlerNotFound = New("HANDLER NOT FOUND")

	ErrObjectNotFound  = New("OBJECT NOT FOUND")
	ErrObjectLocked    = New("OBJECT LOCKED")
	ErrObjectUndefined = New("OBJECT UNDEFINED")

	ErrNotEnoughBalance = New("NOT ENOUGH BALANCE")

	// TYPING

	ErrInvalidTypeNotation = New("INVALID TYPE NOTATION")
	ErrInvalidType         = New("INVALID TYPE")
	ErrIncompatibleTypes   = New("INCOMPATIBLE TYPES")
)
