package exec

import (
	"testing"

	"gitlab.domi.do/avvy/avvy-l3/l3_node_golang/core/rollup"
	"gitlab.domi.do/avvy/avvy-l3/l3_node_golang/core/store"
	"gitlab.domi.do/avvy/avvy-l3/l3_node_golang/core/subscribe"
	"gitlab.domi.do/avvy/avvy-l3/l3_node_golang/utils"
	aproto "gitlab.domi.do/avvy/backend-protocol/proto/avvyprotocol"
)

func TestExec(t *testing.T) {
	a := utils.TestAsserts(t)

	st, err := store.MakeStore("", nil)
	a.Req.NoError(err)
	rollup := rollup.NewRollupProcessor(st)
	exec := NewExecController(subscribe.DefaultManager(), st, rollup)

	go exec.Start()
	defer exec.Stop()

	err = exec.PushMessages([]*aproto.Msg{
		{
			Id:   0,
			Type: "handler",
		},
	})
	a.Req.NoError(err)

}
