package proto

import (
	"encoding/base64"
	"math/rand"

	aproto "gitlab.domi.do/avvy/backend-protocol/proto/avvyprotocol"
)

type ID struct {
	bts []byte
	b64 string
}

func GenerateID() *ID {
	bts := make([]byte, 32)
	rand.Read(bts)
	return NewID(bts)
}

func NewID(bts []byte) (id *ID) {
	if bts != nil {
		id = &ID{
			bts: bts,
			b64: base64.StdEncoding.EncodeToString(bts),
		}
	}
	return
}

func MakeIDFromBase64(base64Str string) (id *ID, err error) {
	bts, err := base64.StdEncoding.DecodeString(base64Str)
	if err != nil {
		return
	}
	id = &ID{
		bts: bts,
		b64: base64Str,
	}
	return
}

func (id *ID) Bytes() []byte {
	return id.bts
}

func (id *ID) Payload() *aproto.Payload {
	return BytesPayload(id.bts)
}

func (id *ID) Base64() string {
	return id.b64
}
