package proto

import (
	"sort"

	aproto "gitlab.domi.do/avvy/backend-protocol/proto/avvyprotocol"
)

type Props struct {
	props []*aproto.Prop
}

func NewProps(props []*aproto.Prop) *Props {
	return &Props{
		props: props,
	}
}

func (props *Props) Props() []*aproto.Prop {
	return props.props
}

func (props *Props) Get(key string) (prop *aproto.Prop) {
	var l, r = 0, len(props.props)
	for l <= r {
		m := (l + r) / 2
		if props.props[m].Name == key {
			prop = props.props[m]
			break
		} else if l == r {
			break
		} else if props.props[m].Name < key {
			l = m + 1
		} else {
			r = m
		}
	}
	return
}

func (props *Props) Len() int {
	return len(props.props)
}

func (props *Props) Less(i, j int) bool {
	return props.props[i].Name < props.props[j].Name
}

func (props *Props) Swap(i, j int) {
	props.props[i], props.props[j] = props.props[j], props.props[i]
}

func (props *Props) Sort() *Props {
	sort.Sort(props)
	return props
}

func (props *Props) Sorted() bool {
	return sort.IsSorted(props)
}
