package spec

type Prop struct {
	name     string
	required bool
	system   bool
}

func (prop *Prop) String() string {
	return prop.name
}

var (
	// Common
	Type = Prop{name: "type", required: true} // string

	Home = Prop{name: "home"} // string

	// Response
	Status = Prop{name: "status"} // int64
	Error  = Prop{name: "error"}  // string

	// For benchmarks
	TxnProcStartAt  = Prop{name: "_txn_proc_start_at", system: true}  // int64 with milliseconds
	TxnProcFinishAt = Prop{name: "_txn_proc_finish_at", system: true} // int64 with milliseconds

	// Subscribe
	SubscribeFilter = Prop{name: "subscribe_filter"} // JSON string

	// BBoxMin = Prop{name: "bbox_min"}
	// BBoxMax = Prop{name: "bbox_max"}

	// Objects
	ObjectID = Prop{name: "object_id"} // string

	Transformation = Prop{name: "transformation"} // [4][4]float64

	Children = Prop{name: "children"} // map[string]Payload
)
