package store

import (
	"github.com/cosmos/cosmos-sdk/store/prefix"
	st_types "github.com/cosmos/cosmos-sdk/store/types"
	"gitlab.domi.do/avvy/avvy-l3/l3_node_golang/core/lang/proto"
)

type indexStore struct {
	store st_types.KVStore
}

func (st *indexStore) Get(key []byte) (ids []*proto.ID) {
	iter := prefix.NewStore(st.store, key).Iterator(nil, nil)
	for iter.Valid() {
		ids = append(ids, proto.NewID(iter.Key()))
		iter.Next()
	}
	return
}

func (st *indexStore) Set(key []byte, id *proto.ID) {
	prefix.NewStore(st.store, key).Set(id.Bytes(), nil)
}

func (st *indexStore) Del(key []byte, id *proto.ID) {
	prefix.NewStore(st.store, key).Delete(id.Bytes())
}
