package utils

import (
	"log"
	"testing"

	"github.com/stretchr/testify/assert"
	"github.com/stretchr/testify/require"
)

type testAsserts struct {
	*assert.Assertions
	Req *require.Assertions
}

func TestAsserts(t interface{}) (a *testAsserts) {
	switch _t := t.(type) {
	case *testing.T:
		a = &testAsserts{
			assert.New(_t),
			require.New(_t),
		}
	case *testing.B:
		a = &testAsserts{
			assert.New(_t),
			require.New(_t),
		}
	default:
		log.Fatalln("Allowed testing.T or testing.B")
	}
	return
}
