package core

import (
	"gitlab.domi.do/avvy/avvy-l3/l3_node_golang/dsl/errors"
	"gitlab.domi.do/avvy/avvy-l3/l3_node_golang/dsl/interfaces"
	aproto "gitlab.domi.do/avvy/backend-protocol/proto/avvyprotocol"
	"go.uber.org/zap"
)

func Payload(unit interfaces.Evaluable, ctx interfaces.Context) (*aproto.Payload, error) {
	if payload, ok := unit.(interfaces.Payloadable); ok {
		return payload.Payload(ctx)
	} else if ctx.IsBreak() {
		return nil, errors.NOT_FULLY_EVALED_ERR
	} else if evaled, err := unit.Eval(ctx); err == nil {
		return Payload(evaled, ctx.WithBreak())
	} else {
		return nil, err
	}
}

func PayloadNoErr(unit interfaces.Unit, ctx interfaces.Context) *aproto.Payload {
	payload, err := Payload(unit, ctx)
	if err != nil {
		logger.Error("noErrEval Error", zap.Error(err))
	}
	return payload
}
